import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.awt.Color;

/**
 * Write a description of class BuildSelection here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class BuildSelection  extends Actor
{
    private GreenfootImage image = new GreenfootImage(50,50);
    private int buildWhat;
    private boolean buildable = false;
    
    public BuildSelection(int buildWhat)
    {
        this.buildWhat = buildWhat;
    }
    
    public void act() 
    {
        checkBuildability();
        draw();
        build();
    }
    
    public void draw()
    {
        if(buildWhat != 3)
        {
            if(buildable == false)
                image.setColor(Color.RED);
            else
                image.setColor(Color.GREEN);
        }
        else if(buildWhat == 3)
        {
            image.setColor(Color.YELLOW);
        }
        image.fillRect(0,0,50,50);
        image.setTransparency(100);
        setImage(image);
        
        if(Greenfoot.mouseMoved(null))
        {
            setLocation(Greenfoot.getMouseInfo().getX(), Greenfoot.getMouseInfo().getY());
        }
    }
    
    public void checkBuildability()
    {
        if(buildWhat == 0 || buildWhat == 2 || buildWhat == 3) // If building pipe or fire, or removing
        {
            if(getOneIntersectingObject(null) == null)
                buildable = true;
            else
                buildable = false;
        }
        if(buildWhat == 1) // If building pot
        {
            if(getOneIntersectingObject(null) != null
              && getOneIntersectingObject(BuildPipeButton.class) == null
              && getOneIntersectingObject(BuildPotButton.class) == null
              && getOneIntersectingObject(BuildFireButton.class) == null
              && getOneIntersectingObject(RemoveButton.class) == null
              && getOneIntersectingObject(EmptyButton.class) == null
              && getOneIntersectingObject(Origin.class) == null
              && getOneIntersectingObject(Pot.class) == null
              && getOneIntersectingObject(Threeway.class) == null)
            {
                buildable = true;
                
                if(getOneIntersectingObject(Twoway.class) != null)
                {
                    if(getOneIntersectingObject(Twoway.class).getRotation() != 180)
                        buildable = false;
                    else
                        buildable = true;
                }
                else if(getOneIntersectingObject(Noway.class) != null)
                {
                    if(getOneIntersectingObject(Noway.class).getRotation() == 90)
                        buildable = false;
                    else
                        buildable = true;
                }
                else if(getOneIntersectingObject(Straight.class) != null)
                {
                    if(getOneIntersectingObject(Straight.class).getRotation() == 90
                      || getOneIntersectingObject(Straight.class).getRotation() == 270)
                        buildable = false;
                    else
                        buildable = true;
                }
                else if(getOneIntersectingObject(Curved.class) != null)
                {
                    if(getOneIntersectingObject(Curved.class).getRotation() == 0
                      || getOneIntersectingObject(Curved.class).getRotation() == 90)
                        buildable = false;
                    else
                        buildable = true;
                }
            }
            else
                buildable = false;
        }
    }
    
    public void build()
    {
        if(Greenfoot.mousePressed(null))
        {
            MouseInfo mouse = Greenfoot.getMouseInfo();
            
            if(mouse.getButton() == 1 && buildable != false)
            {
                if(buildWhat == 0) //Pipe
                    getWorld().addObject(new Straight(), getX(), getY());
                else if(buildWhat == 2) //Fire
                    getWorld().addObject(new Origin(), getX(), getY());
                else if(buildWhat == 1)  //Pot
                    getWorld().addObject(new Pot(), getX(), getY());
                
                getWorld().removeObject(this);
            }
            else if(mouse.getButton() == 1 && buildable == false)
            {
                if(buildWhat == 3 && getOneIntersectingObject(BuildPipeButton.class) == null
                    && getOneIntersectingObject(BuildPotButton.class) == null
                    && getOneIntersectingObject(BuildFireButton.class) == null
                    && getOneIntersectingObject(RemoveButton.class) == null
                    && getOneIntersectingObject(EmptyButton.class) == null) //Remove
                {
                    if(getOneIntersectingObject(Pot.class) != null)
                        getWorld().removeObject(getOneIntersectingObject(Pot.class));
                    else
                        getWorld().removeObject(getOneIntersectingObject(null));
                }
                getWorld().removeObject(this);
            }
            else if(mouse.getButton() == 3)
                getWorld().removeObject(this);
        }
    }
}
