import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class PipeField here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class PipeField
{
    private static PipeIdentity[][] identity = new PipeIdentity[11][16];
    
    public static void setIdentity(PipeIdentity id, int xPosition, int yPosition)
    {
        identity[yPosition][xPosition] = id;
    }
    
    public static Actor getIdealPipe(int xPosition, int yPosition)
    {
        boolean applyNorth = false;
        boolean applyEast = false;
        boolean applySouth = false;
        boolean applyWest = false;
        
        if(yPosition > 0 && identity[yPosition-1][xPosition] != null) // North
        {
            if(identity[yPosition-1][xPosition].applicableFromSouth != false)
            {
                applyNorth = true;
            }
        }
        if(identity[yPosition][xPosition+1] != null) // East
        {
            if(identity[yPosition][xPosition+1].applicableFromWest != false)
            {
                applyEast = true;
            }
        }
        if(identity[yPosition+1][xPosition] != null) // South
        {
            if(identity[yPosition+1][xPosition].applicableFromNorth != false)
            {
                applySouth = true;
            }
        }
        if(xPosition > 0 && identity[yPosition][xPosition-1] != null) // West
        {
            if(identity[yPosition][xPosition-1].applicableFromEast != false)
            {
                applyWest = true;
            }
        }
        
        Actor idealPipe;
        
        if(applyNorth != false && applyEast != false && applySouth != false && applyWest != false)
        {
            idealPipe = new Threeway(0); // Threeway
        }
        else if(applyNorth == false && applyEast != false && applySouth == false && applyWest != false)
        {
            idealPipe = new Straight(0);  // Horizontal Straight
        }
        else if(applyNorth != false && applyEast == false && applySouth != false && applyWest == false)
        {
            idealPipe = new Straight(90); // Vertical Straight
        }
        else if(applyNorth != false && applyEast != false && applySouth == false && applyWest != false)
        {
            idealPipe = new Twoway(0); // Twoway up
        }
        else if(applyNorth != false && applyEast != false && applySouth != false && applyWest == false)
        {
            idealPipe = new Twoway(90); // Twoway right
        }
        else if(applyNorth == false && applyEast != false && applySouth != false && applyWest != false)
        {
            idealPipe = new Twoway(180); // Twoway down
        }
        else if(applyNorth != false && applyEast == false && applySouth != false && applyWest != false)
        {
            idealPipe = new Twoway(270); // Twoway left
        }
        else if(applyNorth == false && applyEast == false && applySouth == false && applyWest != false)
        {
            idealPipe = new Noway(0); // Noway up
        }
        else if(applyNorth != false && applyEast == false && applySouth == false && applyWest == false)
        {
            idealPipe = new Noway(90); // Noway right
        }
        else if(applyNorth == false && applyEast != false && applySouth == false && applyWest == false)
        {
            idealPipe = new Noway(180); // Noway down
        }
        else if(applyNorth == false && applyEast == false && applySouth != false && applyWest == false)
        {
            idealPipe = new Noway(270); // Noway left
        }
        else if(applyNorth != false && applyEast == false && applySouth == false && applyWest != false)
        {
            idealPipe = new Curved(0); // Curved up
        }
        else if(applyNorth != false && applyEast != false && applySouth == false && applyWest == false)
        {
            idealPipe = new Curved(90); // Curved right
        }
        else if(applyNorth == false && applyEast != false && applySouth != false && applyWest == false)
        {
            idealPipe = new Curved(180); // Curved down
        }
        else if(applyNorth == false && applyEast == false && applySouth != false && applyWest != false)
        {
            idealPipe = new Curved(270); // Curved left
        }
        else
        {
            idealPipe = new Straight(0);
        }
        
        return idealPipe;
    }
        
    public static boolean hasToChange(int xPosition, int yPosition)
    {
        if(yPosition > 0 && identity[yPosition-1][xPosition] != null)
        {
            if(identity[yPosition][xPosition].applicableFromNorth == false
                || identity[yPosition-1][xPosition].applicableFromSouth == false)
            {
                return true;
            }
        }
        
        if(identity[yPosition][xPosition+1] != null)
        {
            if(identity[yPosition][xPosition].applicableFromEast == false
                || identity[yPosition][xPosition+1].applicableFromWest == false)
            {
                return true;
            }
        }
        
        if(identity[yPosition+1][xPosition] != null)
        {
            if(identity[yPosition][xPosition].applicableFromSouth == false
                || identity[yPosition+1][xPosition].applicableFromNorth == false)
            {
                return true;
            }
        }
        
        if(xPosition > 0 && identity[yPosition][xPosition-1] != null)
        {
            if(identity[yPosition][xPosition].applicableFromWest == false
                || identity[yPosition][xPosition-1].applicableFromEast == false)
            {
                return true;
            }
        }

        return false;
    }
}
