import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class PipeIdentity here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class PipeIdentity
{
    public boolean applicableFromNorth;
    public boolean applicableFromEast;
    public boolean applicableFromSouth;
    public boolean applicableFromWest;
    public int rotation = 0;
    
    public PipeIdentity(boolean applicableFromNorth, boolean applicableFromEast,
                        boolean applicableFromSouth, boolean applicableFromWest, int rotation)
    {
        this.applicableFromNorth = applicableFromNorth;
        this.applicableFromEast = applicableFromEast;
        this.applicableFromSouth = applicableFromSouth;
        this.applicableFromWest = applicableFromWest;
        
        this.applicableFromNorth = getNorthApplicability(rotation);
        this.applicableFromEast = getEastApplicability(rotation);
        this.applicableFromSouth = getSouthApplicability(rotation);
        this.applicableFromWest = getWestApplicability(rotation);
    }
    
    public boolean getNorthApplicability(int rotation)
    {
        switch(rotation)
        {
            case 0: return applicableFromNorth;
            case 90: return applicableFromEast;
            case 180: return applicableFromSouth;
            case 270: return applicableFromWest;
        }
        return applicableFromNorth;
    }
    public boolean getEastApplicability(int rotation)
    {
        switch(rotation)
        {
            case 0: return applicableFromEast;
            case 90: return applicableFromSouth;
            case 180: return applicableFromWest;
            case 270: return applicableFromNorth;
        }
        return applicableFromNorth;
    }
    public boolean getSouthApplicability(int rotation)
    {
        switch(rotation)
        {
            case 0: return applicableFromSouth;
            case 90: return applicableFromWest;
            case 180: return applicableFromNorth;
            case 270: return applicableFromEast;
        }
        return applicableFromNorth;
    }
    public boolean getWestApplicability(int rotation)
    {
        switch(rotation)
        {
            case 0: return applicableFromWest;
            case 90: return applicableFromNorth;
            case 180: return applicableFromEast;
            case 270: return applicableFromSouth;
        }
        return applicableFromNorth;
    }
    
    public int getTypeOfPipe()
    {
        int pipeNumber = 0;
        
        if(getNorthApplicability(0) && getEastApplicability(0))
            pipeNumber++;
        if(getEastApplicability(0) && getSouthApplicability(0))
            pipeNumber++;
        if(getSouthApplicability(0) && getWestApplicability(0))
            pipeNumber++;
        if(getWestApplicability(0) && getNorthApplicability(0))
            pipeNumber++;   // 4= Threeway, 2= Twoway, 1= Curved
            
        if(pipeNumber == 0)
        {
            if(getEastApplicability(0) == getWestApplicability(0))
                pipeNumber = 5;
            else
                pipeNumber = 0;
        }
            
        return pipeNumber; // 4= Threeway, 2= Twoway, 1= Curved, 5= Straight, 0= Noway
    }
}
